function selectedHTML() {
	let html = "";
	let sel = window.getSelection();
	if(sel.rangeCount) {
		let container = document.createElement("div");
		for(let i = 0, len = sel.rangeCount; i < len; ++i) {
			container.appendChild(sel.getRangeAt(i).cloneContents());
		}
		html = container.innerHTML;
	}
	return html;
}

function getSelectionAndSendMessage() {
	window.webkit.messageHandlers.selectionMessageHandler.postMessage(selectedHTML());
}

document.onselectionchange = getSelectionAndSendMessage;

// Drop these if the above works (which it appears to do on at least 10.15+)
// document.onmouseup      = getSelectionAndSendMessage;
// document.onkeyup        = getSelectionAndSendMessage;
// document.oncontextmenu  = getSelectionAndSendMessage;
